import { j as n } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as Ce, useState as q, useMemo as w, useRef as L, useEffect as me, useCallback as ve } from "react";
import { isMobile as p } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as pe, Table as E, Skeleton as Be } from "antd";
import ze from "../../BitzDrawer/index.mjs";
import ke from "../../BitzLoadMore/index.mjs";
import Te from "../../BitzPagination/index.mjs";
import Me from "../../BitzNoData/index.mjs";
import Le, { TableContext as Ee } from "../Store/index.mjs";
import Ae from "../TableSkeleton/index.mjs";
import { columnSort as X, genColumnKey as F } from "../Store/utils/index.mjs";
import G from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import He from "../../../node_modules/lodash-es/at.mjs";
function We({
  showPagination: C = !0,
  fillEvenRow: A = !0,
  evenRowBgColor: H = "#f9f9f9",
  height: m,
  dataSource: r = [],
  total: B = 0,
  columns: x,
  loading: j = !1,
  skeletonNum: J = 2,
  skeletonRender: W,
  skeletonRowNum: Q = 4,
  skeletonRowsWidth: S = ["35%", "100%", "100%", "60%"],
  mobileLoadEmit: Y = () => {
  },
  mobileRefreshEmit: Z = () => {
  },
  operationFilter: z,
  enableControlPage: I,
  pagination: v,
  paginationEmit: ee = () => {
  },
  mobilePageHeight: ne = 500,
  mobileCancelText: se = "取消",
  noDataTitle: le,
  noDataImg: re,
  color: oe,
  size: O,
  showTableTool: te = !0,
  tableAction: ie,
  tableToolbar: ae,
  selectionBar: de,
  scroll: i,
  resetPage: he,
  ...a
}) {
  const { token: ce } = pe.useToken(), d = Ce(Ee), [fe, k] = q(!1), xe = w(() => !!(r != null && r.length) && (r == null ? void 0 : r.length) >= B, [r, B]), [be, ue] = q([]), ye = (s, e) => {
    var c;
    const l = (c = z == null ? void 0 : z(s, e)) == null ? void 0 : c.filter(
      (h) => h.type !== "divider"
    );
    l != null && l.length && (ue(l), k(!0));
  }, P = () => {
    k(!1);
  }, we = (s) => {
    var e;
    k(!1), (e = s.onClick) == null || e.call(s);
  }, b = L(null), u = G(b), _ = L(null), y = G(_), $ = L(null), je = (s) => {
    var R, U;
    const e = s.length, l = s.filter((f) => f.width), h = l.map((f) => f.width).reduce((f, Ne) => f + Ne, 0);
    let t = 0;
    if (b.current) {
      const f = window.getComputedStyle(b.current);
      t = parseInt(f.getPropertyValue("--toolCell-width"));
    }
    let o = 0;
    a.rowSelection && (o += t), a.expandable && (o += t);
    const M = (U = (R = $.current) == null ? void 0 : R.querySelector(".ant-table-body")) == null ? void 0 : U.clientWidth, N = (parseInt(`${M}`) || 0) - h - o;
    return N >= 0 ? N / (e - l.length) : void 0;
  }, g = w(() => {
    const s = (t) => t.map((o) => {
      const M = F(
        (o == null ? void 0 : o.key) || (o == null ? void 0 : o.dataIndex),
        o.index
      ), N = d.columnsMap[M];
      return N && N.show === !1 ? !1 : o.children ? {
        ...o,
        children: s(o.children)
      } : o;
    }).filter(Boolean), e = s(x);
    if (p)
      return e.sort(X(d.columnsMap));
    const l = e.sort(X(d.columnsMap)), c = je(l), h = l.map((t, o) => ({
      ...t,
      ...t.width ? {} : {
        // 给未设置width的列设置平均数
        width: c
      }
    }));
    return [E.SELECTION_COLUMN, E.EXPAND_COLUMN, ...h];
  }, [
    d.columnsMap,
    x,
    p,
    a.rowSelection,
    a.expandable,
    u == null ? void 0 : u.height
  ]);
  me(() => {
    if (x && x.length > 0) {
      const s = x.map(
        (e) => (
          // @ts-ignore
          F((e == null ? void 0 : e.key) ?? (e == null ? void 0 : e.dataIndex), e == null ? void 0 : e.dataIndex)
        )
      );
      d.setSortKeyColumns(s);
    }
  }, [x]);
  const { y: T } = w(() => {
    if (typeof m > "u")
      return {};
    let s = 40, e = 40;
    if (b.current) {
      const t = window.getComputedStyle(b.current);
      s = parseInt(
        t.getPropertyValue("--cell-block") || "40"
      ), e = parseInt(
        t.getPropertyValue("--toolbar-height") || "40"
      );
    }
    const l = y == null ? void 0 : y.height;
    return { y: m - (l || 0) - e - s };
  }, [m, y == null ? void 0 : y.height, u == null ? void 0 : u.height]), D = w(() => i != null && i.x ? { x: i.x, y: i.y || T } : i != null && i.y ? { x: 1e3, y: i.y } : { x: 1e3, y: T }, [i, T]), ge = w(() => `${O ?? (d == null ? void 0 : d.tableSize) ?? "lg"}BitzTable`, [O, d.tableSize]), K = w(() => ({
    "--evenRow-BgColor": H
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    H
    /** token.Table?.borderColor */
  ]), V = ve(
    (s, e) => A ? e % 2 === 0 ? "oddRow" : "evenRow" : "",
    [A]
  );
  return /* @__PURE__ */ n.jsxs("div", { className: "bitzTableBlock", children: [
    !p && /* @__PURE__ */ n.jsxs(
      "div",
      {
        ref: b,
        className: `bitzTableContainer ${ge}`,
        style: { height: m },
        children: [
          /* @__PURE__ */ n.jsxs("div", { className: "bitzTableContainerBody", ref: $, children: [
            te && /* @__PURE__ */ n.jsxs("div", { className: "bitzTableToolbarBlock", children: [
              ie || /* @__PURE__ */ n.jsx("div", {}),
              ae,
              (a == null ? void 0 : a.rowSelection) && /* @__PURE__ */ n.jsx(n.Fragment, { children: de })
            ] }),
            /* @__PURE__ */ n.jsx(
              E,
              {
                columns: g,
                dataSource: r,
                loading: !1,
                pagination: !1,
                scroll: D,
                ...a,
                style: K,
                rowClassName: V
              }
            ),
            /* @__PURE__ */ n.jsx(
              Ae,
              {
                columns: g,
                skeletonLength: (v == null ? void 0 : v.size) || 10,
                scroll: D,
                rowSelection: a.rowSelection,
                expandable: a.expandable,
                style: K,
                rowClassName: V,
                loading: j
              }
            )
          ] }),
          C && /* @__PURE__ */ n.jsx(
            Te,
            {
              ref: _,
              enableControl: I,
              pagination: v,
              total: B,
              dataSource: r,
              resetPage: he,
              paginationEmit: ee
            }
          )
        ]
      }
    ),
    p && /* @__PURE__ */ n.jsxs(n.Fragment, { children: [
      (j || (r == null ? void 0 : r.length) > 0) && /* @__PURE__ */ n.jsx(
        ke,
        {
          color: oe,
          height: ne,
          loading: j,
          showNoMore: xe,
          refreshEmit: Z,
          loadEmit: Y,
          extra: /* @__PURE__ */ n.jsxs("div", { className: "mobileTable", children: [
            r == null ? void 0 : r.map((s, e) => /* @__PURE__ */ n.jsx(
              "div",
              {
                className: "mobileTableRow",
                onClick: () => ye(s, e),
                children: /* @__PURE__ */ n.jsx("div", { className: "rowBox", children: g == null ? void 0 : g.map(
                  (l, c) => {
                    var h;
                    return /* @__PURE__ */ n.jsx("div", { children: !(l != null && l.mobileHideRow) && /* @__PURE__ */ n.jsxs("div", { className: "row", children: [
                      !l.mobileHideLabel && /* @__PURE__ */ n.jsxs("div", { className: "label", children: [
                        `${l.title}`,
                        "："
                      ] }),
                      /* @__PURE__ */ n.jsx("div", { className: "value", children: ((h = l == null ? void 0 : l.render) == null ? void 0 : h.call(
                        l,
                        He(s, (l == null ? void 0 : l.dataIndex) || ""),
                        s,
                        e
                      )) || (s == null ? void 0 : s[l.dataIndex]) })
                    ] }) }, c);
                  }
                ) })
              },
              e
            )),
            j && Array.from({ length: J }).map((s, e) => /* @__PURE__ */ n.jsx("div", { className: "mobileTableRow", children: /* @__PURE__ */ n.jsx("div", { className: "rowBox", children: W ? W() : /* @__PURE__ */ n.jsx(
              Be,
              {
                title: !1,
                paragraph: {
                  rows: Q,
                  width: S
                },
                active: !0
              }
            ) }) }, e)),
            /* @__PURE__ */ n.jsx(
              ze,
              {
                className: "tableMobileDrawer",
                open: fe,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: P,
                children: /* @__PURE__ */ n.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ n.jsx("div", { className: "boxBody", children: be.map((s, e) => /* @__PURE__ */ n.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => we(s),
                      ...s.danger && {
                        style: { color: ce.colorError }
                      },
                      children: s.label
                    },
                    e
                  )) }),
                  /* @__PURE__ */ n.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ n.jsx("div", { className: "boxFooter", onClick: P, children: se })
                ] })
              }
            )
          ] })
        }
      ),
      !j && /* @__PURE__ */ n.jsx(Me, { data: r, title: le, img: re })
    ] })
  ] });
}
const Qe = (C) => (
  // @ts-ignore
  /* @__PURE__ */ n.jsx(Le, { initValue: C, children: /* @__PURE__ */ n.jsx(We, { ...C }) })
);
export {
  Qe as default
};
